#include <test-dll/objects.hpp>

#include <algorithm>
#include <memory>

#include <boost/range/algorithm/fill.hpp>

///////////////////////////////////////////////////////////////////////////////
cpe::object_t::object_t(id_t id)
  : id{id}
{}

cpe::object_t::~object_t() = default;

///////////////////////////////////////////////////////////////////////////////
cpe::derived_t::derived_t(
    id_t          id
  , const double* params)
  : object_t{id}
{
  if(params)
    std::copy_n(params, size, this->params);
  else
    boost::fill(this->params, 0.0);
}

cpe::derived_t::~derived_t() = default;
