#ifndef TEST_DLL_OBJECTS_HPP
#define TEST_DLL_OBJECTS_HPP

#pragma warning(push)
#pragma warning(disable: 4251)

#include <test-dll/autolink.hpp>

namespace cpe {
  using id_t = unsigned int;

  class CPE_API object_t {
  public:
    object_t(id_t id = 0);
    virtual ~object_t();

    const id_t id;
  };

  class CPE_API derived_t: public object_t {
  public:
    derived_t(
        id_t          id     = 0
      , const double* params = nullptr);
    ~derived_t() override;

    derived_t(const derived_t&) = delete;
    const derived_t& operator=(const derived_t&) = delete;

    static constexpr unsigned int size{23};
    double                    params[size];
  };
}

#endif
