#include <test-dll/serialize.hpp>

#pragma warning(push)
#pragma warning(disable:4267 4099 4244)
#include <boost/serialization/base_object.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/nvp.hpp>
#pragma warning(pop)

namespace boost::serialization {
  /////////////////////////////////////////////////////////////////////////////
  template<class Archive>
  void
  serialize(Archive& ar, cpe::object_t& o, const unsigned int version)
  {
    ar & make_nvp("o.id", const_cast<cpe::id_t&>(o.id));
  }

  /////////////////////////////////////////////////////////////////////////////
  template<class Archive>
  void
  serialize(Archive& ar, cpe::derived_t& c, const unsigned int version)
  {
    ar & make_nvp("object", base_object<cpe::object_t>(c));
    ar & BOOST_SERIALIZATION_NVP(c.params);
  }
}

///////////////////////////////////////////////////////////////////////////////
BOOST_CLASS_EXPORT_IMPLEMENT(cpe::object_t)
BOOST_CLASS_EXPORT_IMPLEMENT(cpe::derived_t)

#include <boost/archive/xml_iarchive.hpp>
#include <boost/archive/xml_oarchive.hpp>

namespace boost::serialization {
  template CPE_API void
  serialize(archive::xml_iarchive&, cpe::object_t&, const unsigned int);
  template CPE_API void
  serialize(archive::xml_oarchive&, cpe::object_t&, const unsigned int);

  template CPE_API void
  serialize(archive::xml_iarchive&, cpe::derived_t&, const unsigned int);
  template CPE_API void
  serialize(archive::xml_oarchive&, cpe::derived_t&, const unsigned int);
}
